SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

Magnitude subclass: #Measure
	instanceVariableNames: 'amount unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Measure class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/4/2012 19:36'!
withAmount: anAmount ofUnit: anUnit 

	^(self new setAmount: anAmount) setUnit: anUnit! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/4/2012 19:55'!
withBase: aBaseAmount ofUnit:aUnit
	
	^ Measure withAmount: (aUnit conversionFromBase value: aBaseAmount)  ofUnit: aUnit . ! !

!Measure methodsFor: 'operating' stamp: 'RavasiAronson 6/5/2012 01:43'!
* anObject
	self class = anObject class
		ifTrue: [ ^(Measure withAmount: (self convertToBase * anObject convertToBase) ofUnit: (self unit multiplyBy: anObject unit)) simplify   ]
		ifFalse: [ ^ Measure withAmount: self amount * anObject ofUnit: self unit ]! !

!Measure methodsFor: 'operating' stamp: 'RavasiAronson 6/4/2012 19:51'!
+ aMeasure  
	self checkSameMagnitude: aMeasure.
	^ Measure withBase: (self convertToBase + aMeasure convertToBase) ofUnit: self unit.! !

!Measure methodsFor: 'operating' stamp: 'RavasiAronson 6/4/2012 19:57'!
- aMeasure 
	self checkSameMagnitude: aMeasure.
	^ Measure withBase: (self convertToBase - aMeasure convertToBase) ofUnit: self unit.! !

!Measure methodsFor: 'operating' stamp: 'RavasiAronson 6/5/2012 00:53'!
/ anObject 
	
	self class = anObject class
		ifTrue: [ ^(Measure withAmount: (self convertToBase / anObject convertToBase) ofUnit: (self unit divideBy: anObject unit)) simplify ]
		ifFalse: [ ^ Measure withAmount: self amount / anObject ofUnit: self unit ]! !

!Measure methodsFor: 'comparing' stamp: 'RavasiAronson 5/22/2012 23:14'!
< aDistance 

	^ self convertToBase < aDistance convertToBase ! !

!Measure methodsFor: 'comparing' stamp: 'RavasiAronson 6/5/2012 01:33'!
= aMeasure
	aMeasure class = self class
		ifTrue: [ 
			(self isSameMagnitude: aMeasure)
				ifTrue: [ ^ self convertToBase = aMeasure convertToBase ]
				ifFalse: [ ^self isZero & aMeasure isZero. ]]
		ifFalse: [ ^ false ]! !

!Measure methodsFor: 'accessing' stamp: 'RavasiAronson 5/22/2012 21:16'!
amount
	
	^ amount.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/4/2012 19:45'!
checkSameMagnitude: aMeasure
	(self isSameMagnitude: aMeasure)
		ifFalse: [ CanNotConvertUnitException new signal]! !

!Measure methodsFor: 'converting' stamp: 'RavasiAronson 6/4/2012 21:14'!
convertTo: aDistanceUnit
	| amountInBase |
	(self unit sameNumerator: aDistanceUnit) & (self unit sameDenominator: aDistanceUnit)
		ifTrue: [ 
			amountInBase := self unit conversionToBase value: self amount.
			^ Measure withAmount: (aDistanceUnit conversionFromBase value: amountInBase) ofUnit: aDistanceUnit ]
		ifFalse: [ CanNotConvertUnitException new signal ]! !

!Measure methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/30/2012 20:26'!
convertToBase
	
	^ self unit conversionToBase value: amount ! !

!Measure methodsFor: 'comparing' stamp: 'RavasiAronson 5/22/2012 22:28'!
hash 

	^ self convertToBase hash! !

!Measure methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/4/2012 21:13'!
isSameMagnitude: aMeasure 
		
	^ (self unit sameNumerator: aMeasure unit) & (self unit sameDenominator: aMeasure unit)! !

!Measure methodsFor: 'comparing' stamp: 'RavasiAronson 6/5/2012 01:33'!
isZero
	
	^ amount = 0! !

!Measure methodsFor: 'operating' stamp: 'RavasiAronson 5/30/2012 19:07'!
negated
	^Measure withAmount: (0 - self amount) ofUnit: self unit.! !

!Measure methodsFor: 'printing' stamp: 'RavasiAronson 5/22/2012 22:13'!
printOn: aStream 

	self amount printOn: aStream.
	
	aStream nextPutAll: ' '.
	
	self unit printOn: aStream.

	self amount > 1 ifTrue: [aStream nextPutAll: 's'.]! !

!Measure methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/22/2012 21:37'!
setAmount: anAmount

	amount := anAmount .! !

!Measure methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/22/2012 21:37'!
setUnit: aUnit

	unit := aUnit .! !

!Measure methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/5/2012 00:55'!
simplify
	self unit simplify isUnitEmpty ifTrue: [^self amount]! !

!Measure methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/30/2012 19:07'!
to: aDistance 
	 ^DistanceInterval from: self to: aDistance by: (Measure withAmount: 1 ofUnit: self unit).! !

!Measure methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/23/2012 19:08'!
to: aDistance by: aDistance2 
	 ^DistanceInterval from: self to: aDistance by: aDistance2 ! !

!Measure methodsFor: 'accessing' stamp: 'RavasiAronson 5/22/2012 21:16'!
unit
	^ unit! !

Error subclass: #CanNotConvertUnitException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Object subclass: #Unit
	instanceVariableNames: 'name numerator denominator conversionToBase conversionFromBase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Unit class methodsFor: 'acceleration units' stamp: 'RavasiAronson 6/5/2012 01:24'!
acceleration
	^Unit withArrayNumerator: #('distance')  andDenominator: #('time' 'time')! !

!Unit class methodsFor: 'area units' stamp: 'RavasiAronson 6/5/2012 00:42'!
area 

	^Unit withArrayNumerator: #('distance' 'distance')  andDenominator: #() ! !

!Unit class methodsFor: 'temperature units' stamp: 'RavasiAronson 5/30/2012 21:10'!
celsius 

	^Unit temperature withName: 'celsius' withConversionToBase:  [:aValue | aValue] withConversionFromBase:  [:aValue | aValue]! !

!Unit class methodsFor: 'distance units' stamp: 'RavasiAronson 6/5/2012 00:11'!
centimeter

	^Unit distance withName:'centimeter' withConversionToBase:  [:aValue | aValue / 100] withConversionFromBase:  [:aValue | aValue * 100]! !

!Unit class methodsFor: 'volume units' stamp: 'RavasiAronson 6/5/2012 00:22'!
cubicMeter
	^ Unit volume
		withName: 'meter*meter*meter'
		withConversionToBase: [ :aValue | aValue  ]
		withConversionFromBase: [ :aValue | aValue  ]! !

!Unit class methodsFor: 'time units' stamp: 'RavasiAronson 5/30/2012 21:11'!
day
	^ Unit time withName: 'day' withConversionToBase: [ :aValue | 86400 * aValue ] withConversionFromBase:  [:aValue |  aValue / 86400]! !

!Unit class methodsFor: 'distance units' stamp: 'RavasiAronson 6/5/2012 00:11'!
decameter
	
	^Unit distance withName:'decameter' withConversionToBase: [:aValue | aValue *10] withConversionFromBase:  [:aValue | aValue / 10]! !

!Unit class methodsFor: 'distance units' stamp: 'RavasiAronson 6/5/2012 00:11'!
decimeter
	^ Unit distance
		withName: 'decimeter'
		withConversionToBase: [ :aValue | aValue / 10 ]
		withConversionFromBase: [ :aValue | aValue * 10 ]! !

!Unit class methodsFor: 'distance units' stamp: 'RavasiAronson 6/4/2012 20:50'!
distance

	^ Unit withBasicMagnitude: 'distance'! !

!Unit class methodsFor: 'distance by time units' stamp: 'RavasiAronson 6/5/2012 00:43'!
distanceByTime 
	
	^Unit withArrayNumerator: #('distance' 'time')  andDenominator: #() ! !

!Unit class methodsFor: 'temperature units' stamp: 'RavasiAronson 5/30/2012 21:13'!
fahrenheit
	^ Unit temperature
		withName: 'fahrenheit'
		withConversionToBase: [ :aValue | (aValue - 32) * (5 / 9) ]
		withConversionFromBase: [ :aValue | aValue * (9 / 5) + 32 ]! !

!Unit class methodsFor: 'distance units' stamp: 'RavasiAronson 6/5/2012 00:11'!
hectometer
	^ Unit distance
		withName: 'hectometer'
		withConversionToBase: [ :aValue | aValue * 100 ]
		withConversionFromBase: [ :aValue | aValue / 100 ]! !

!Unit class methodsFor: 'time units' stamp: 'RavasiAronson 5/30/2012 21:14'!
hour
	^ Unit time
		withName: 'hour'
		withConversionToBase: [ :aValue | 3600 * aValue ]
		withConversionFromBase: [ :aValue | aValue / 3600 ]! !

!Unit class methodsFor: 'temperature units' stamp: 'RavasiAronson 5/30/2012 21:14'!
kelvin
	^ Unit temperature
		withName: 'kelvin'
		withConversionToBase: [ :aValue | aValue + 273 ]
		withConversionFromBase: [ :aValue | aValue - 273 ]! !

!Unit class methodsFor: 'distance units' stamp: 'RavasiAronson 6/5/2012 00:12'!
kilometer
	^ Unit distance
		withName: 'kilometer'
		withConversionToBase: [ :aValue | aValue * 1000 ]
		withConversionFromBase: [ :aValue | aValue / 1000 ]! !

!Unit class methodsFor: 'distance units' stamp: 'RavasiAronson 6/5/2012 00:12'!
meter
	^ Unit distance
		withName: 'meter'
		withConversionToBase: [ :aValue |  aValue ]
		withConversionFromBase: [ :aValue | aValue ]! !

!Unit class methodsFor: 'velocity units' stamp: 'RavasiAronson 6/5/2012 01:17'!
meterPerSecond
	^ Unit velocity
		withName: 'meter/second'
		withConversionToBase: [ :aValue | aValue  ]
		withConversionFromBase: [ :aValue | aValue  ]! !

!Unit class methodsFor: 'acceleration units' stamp: 'RavasiAronson 6/5/2012 01:24'!
meterPerSquaredSecond
	^ Unit acceleration 
		withName: 'meter/second*second'
		withConversionToBase: [ :aValue | aValue  ]
		withConversionFromBase: [ :aValue | aValue  ]! !

!Unit class methodsFor: 'distance by time units' stamp: 'RavasiAronson 6/5/2012 00:43'!
meterTimesSecond
	^ Unit distanceByTime 
		withName: 'meter*second'
		withConversionToBase: [ :aValue | aValue  ]
		withConversionFromBase: [ :aValue | aValue  ]! !

!Unit class methodsFor: 'distance units' stamp: 'RavasiAronson 6/5/2012 00:12'!
milimeter
	^ Unit distance
		withName: 'milimeter'
		withConversionToBase: [ :aValue | aValue / 1000 ]
		withConversionFromBase: [ :aValue | aValue * 1000 ]! !

!Unit class methodsFor: 'time units' stamp: 'RavasiAronson 5/30/2012 21:15'!
minute
	^ Unit time
		withName: 'minute'
		withConversionToBase: [ :aValue | 60 * aValue ]
		withConversionFromBase: [ :aValue | aValue / 60 ]! !

!Unit class methodsFor: 'time units' stamp: 'RavasiAronson 5/30/2012 21:15'!
second
	
	^Unit time withName: 'second' withConversionToBase:  [:aValue |  aValue] withConversionFromBase:  [:aValue |  aValue]! !

!Unit class methodsFor: 'area units' stamp: 'RavasiAronson 6/5/2012 00:12'!
squaredMeter
	^ Unit area
		withName: 'meter*meter'
		withConversionToBase: [ :aValue | aValue  ]
		withConversionFromBase: [ :aValue | aValue  ]! !

!Unit class methodsFor: 'squared time units' stamp: 'RavasiAronson 6/5/2012 00:27'!
squaredSecond
	^ Unit squaredTime
		withName: 'second*second'
		withConversionToBase: [ :aValue | aValue  ]
		withConversionFromBase: [ :aValue | aValue  ]! !

!Unit class methodsFor: 'squared time units' stamp: 'RavasiAronson 6/5/2012 00:43'!
squaredTime
	^Unit withArrayNumerator: #('time' 'time')  andDenominator: #() ! !

!Unit class methodsFor: 'temperature units' stamp: 'RavasiAronson 6/4/2012 20:50'!
temperature 

	^Unit withBasicMagnitude: 'temperature'! !

!Unit class methodsFor: 'time units' stamp: 'RavasiAronson 6/4/2012 20:50'!
time

	^Unit withBasicMagnitude: 'time'! !

!Unit class methodsFor: 'velocity units' stamp: 'RavasiAronson 6/5/2012 01:16'!
velocity
	^ Unit withArrayNumerator: #('distance') andDenominator: #('time')! !

!Unit class methodsFor: 'volume units' stamp: 'RavasiAronson 6/5/2012 00:44'!
volume
	^ Unit withArrayNumerator: #('distance' 'distance' 'distance') andDenominator: #()! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/5/2012 00:37'!
withArrayNumerator: anArray andDenominator: anArray2 
	
	|aBag aBag2|
	aBag := Bag new.
	aBag2 := Bag new.
	
	anArray do:[:each | aBag add: each.].
	anArray2 do:[:each | aBag2 add: each.].
	
	^(Unit new setNumerator: aBag ) setDenominator: aBag2! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/4/2012 21:31'!
withBasicMagnitude: aMagnitude 
	
	|numeratorBag|
	numeratorBag := Bag new.
	numeratorBag add: aMagnitude.
	
^ (self new setNumerator: numeratorBag) setDenominator: (Bag  new) ! !

!Unit methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/4/2012 21:29'!
= aUnit
	^ (name = aUnit name) & (self sameNumerator: aUnit ) & (self sameDenominator: aUnit)! !

!Unit methodsFor: 'accessing' stamp: 'RavasiAronson 5/30/2012 21:16'!
conversionFromBase
	^ conversionFromBase! !

!Unit methodsFor: 'accessing' stamp: 'RavasiAronson 5/30/2012 20:25'!
conversionToBase
	^ conversionToBase! !

!Unit methodsFor: 'accessing' stamp: 'RavasiAronson 6/4/2012 20:40'!
denominator
	^denominator! !

!Unit methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/5/2012 01:21'!
divideBy: aUnit 
	self denominator addAll: (aUnit numerator) .
	self numerator addAll: (aUnit denominator) .
	name := name, '/', aUnit name.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/5/2012 01:07'!
isUnitEmpty
	^numerator isEmpty & denominator isEmpty ! !

!Unit methodsFor: 'converting' stamp: 'RavasiAronson 6/5/2012 01:21'!
multiplyBy: aUnit 
	self numerator addAll: (aUnit numerator) .
	self denominator  addAll: (aUnit denominator) .
	name := name, '*', aUnit name.! !

!Unit methodsFor: 'accessing' stamp: 'RavasiAronson 5/22/2012 21:44'!
name

	^name.! !

!Unit methodsFor: 'accessing' stamp: 'RavasiAronson 6/4/2012 20:40'!
numerator
	^numerator.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/22/2012 22:01'!
printOn: aStream

	aStream nextPutAll: self name ! !

!Unit methodsFor: 'comparing' stamp: 'RavasiAronson 6/4/2012 21:28'!
sameDenominator: aUnit 
	^denominator  = aUnit denominator.! !

!Unit methodsFor: 'comparing' stamp: 'RavasiAronson 6/4/2012 21:28'!
sameNumerator: aUnit 
	^numerator = aUnit numerator.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/30/2012 21:08'!
setConversionFromBase: aBlock
	
	conversionFromBase  := aBlock! !

!Unit methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/30/2012 20:26'!
setConversionToBase: aBlock
	
	conversionToBase  := aBlock! !

!Unit methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/4/2012 20:51'!
setDenominator: aCollectionOfMagnitudes
	
	denominator  := aCollectionOfMagnitudes! !

!Unit methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/30/2012 19:39'!
setMagnitude: aMagnitude
	
	magnitude := aMagnitude! !

!Unit methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/22/2012 21:32'!
setName: aName
	
	name := aName! !

!Unit methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/4/2012 20:51'!
setNumerator: aCollectionOfMagnitudes
	
	numerator  := aCollectionOfMagnitudes! !

!Unit methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 6/5/2012 01:04'!
simplify
	numerator
		do: [ :each | 
			[ 
			denominator remove: each.
			numerator remove: each ]
				on: NotFound
				do: [  ] ]! !

!Unit methodsFor: 'as yet unclassified' stamp: 'RavasiAronson 5/30/2012 21:10'!
withName: aName withConversionToBase: aBlock withConversionFromBase: anotherBlock

^((self setName: aName) setConversionToBase: aBlock) setConversionFromBase: anotherBlock! !

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'RavasiAronson 6/4/2012 19:25'!
canNotConvertMeasurementException
	
	^CanNotConvertUnitException.! !

!MeasureTest methodsFor: 'temperature units' stamp: 'RavasiAronson 5/30/2012 20:40'!
celsius
	
	^Unit celsius ! !

!MeasureTest methodsFor: 'distance units' stamp: 'RavasiAronson 5/30/2012 20:36'!
centimeter
	
	^Unit centimeter ! !

!MeasureTest methodsFor: 'time units' stamp: 'RavasiAronson 5/30/2012 20:40'!
day
	
	^Unit day! !

!MeasureTest methodsFor: 'distance units' stamp: 'RavasiAronson 5/30/2012 20:38'!
decameter
	
	^Unit decameter! !

!MeasureTest methodsFor: 'distance units' stamp: 'RavasiAronson 5/30/2012 20:36'!
decimeter
	
	^Unit decimeter! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceExamples 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceUnits 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'RavasiAronson 6/5/2012 00:23'!
eightCubicMeters

	^Measure withAmount: 8 ofUnit: Unit cubicMeter  ! !

!MeasureTest methodsFor: 'temperature units' stamp: 'RavasiAronson 5/30/2012 20:40'!
fahrenheit
	
	^Unit fahrenheit ! !

!MeasureTest methodsFor: 'compound measures' stamp: 'RavasiAronson 6/5/2012 01:42'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod

	"Implementar la formula de velocidad final: vf = vi + a * t"
	
	|velocity|
	
	velocity := (initialSpeed amount)  + ((anAcceleration amount) * (aTimePeriod amount)).
	
	^ Measure withAmount: velocity ofUnit: Unit meterPerSecond.
	! !

!MeasureTest methodsFor: 'compound measures' stamp: 'RavasiAronson 6/5/2012 00:16'!
fourSquaredMeters

	^Measure withAmount: 4 ofUnit: Unit squaredMeter  ! !

!MeasureTest methodsFor: 'distance units' stamp: 'RavasiAronson 5/30/2012 20:38'!
hectometer
	
	^Unit hectometer! !

!MeasureTest methodsFor: 'time units' stamp: 'RavasiAronson 5/30/2012 20:42'!
hour
	
	^Unit hour! !

!MeasureTest methodsFor: 'temperature units' stamp: 'RavasiAronson 5/30/2012 20:48'!
kelvin
	
	^Unit kelvin ! !

!MeasureTest methodsFor: 'distance units' stamp: 'RavasiAronson 5/30/2012 20:39'!
kilometer
	
	^Unit kilometer ! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'RavasiAronson 5/30/2012 20:36'!
meter

	^Unit meter! !

!MeasureTest methodsFor: 'distance units' stamp: 'RavasiAronson 5/30/2012 20:37'!
millimeter
	
	^Unit milimeter ! !

!MeasureTest methodsFor: 'distance measures' stamp: 'RavasiAronson 6/4/2012 19:58'!
minusOneMeter 
	
	^Measure withAmount: -1 ofUnit: Unit meter ! !

!MeasureTest methodsFor: 'time units' stamp: 'RavasiAronson 5/30/2012 20:42'!
minute
	
	^Unit minute! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'RavasiAronson 5/30/2012 20:32'!
oneCelsius
	
	^Measure withAmount: 1 ofUnit: (Unit celsius)! !

!MeasureTest methodsFor: 'distance measures' stamp: 'RavasiAronson 6/4/2012 19:58'!
oneCentimeter
	
	^Measure withAmount: 1 ofUnit: Unit centimeter  ! !

!MeasureTest methodsFor: 'time measures' stamp: 'RavasiAronson 5/30/2012 21:17'!
oneDay
	
	^Measure withAmount: 1 ofUnit: (Unit day) ! !

!MeasureTest methodsFor: 'time measures' stamp: 'RavasiAronson 5/30/2012 21:16'!
oneHour
	
	^Measure withAmount: 1 ofUnit: (Unit hour) ! !

!MeasureTest methodsFor: 'distance measures' stamp: 'RavasiAronson 5/30/2012 20:14'!
oneHundredCentimeters
	
	^Measure withAmount: 100  ofUnit: (Unit centimeter) ! !

!MeasureTest methodsFor: 'compound measures' stamp: 'RavasiAronson 6/5/2012 01:44'!
oneHundredTwentyOneMetersPerSecond

	^Measure withAmount: 121 ofUnit: Unit meterPerSecond! !

!MeasureTest methodsFor: 'distance measures' stamp: 'RavasiAronson 5/30/2012 20:11'!
oneMeter
	
	^Measure withAmount: 1 ofUnit: Unit meter ! !

!MeasureTest methodsFor: 'compound measures' stamp: 'RavasiAronson 6/5/2012 01:22'!
oneMeterPerSecond

	^Measure withAmount: 1 ofUnit: Unit meterPerSecond  ! !

!MeasureTest methodsFor: 'time measures' stamp: 'RavasiAronson 5/30/2012 20:16'!
oneMinute
	
	^Measure withAmount: 1 ofUnit: (Unit minute) ! !

!MeasureTest methodsFor: 'time measures' stamp: 'RavasiAronson 5/30/2012 20:12'!
oneSecond

	^Measure withAmount: 1 ofUnit: (Unit second) ! !

!MeasureTest methodsFor: 'compound measures' stamp: 'RavasiAronson 6/4/2012 21:44'!
oneSquaredMeter

	^Measure withAmount: 1 ofUnit: Unit squaredMeter  ! !

!MeasureTest methodsFor: 'compound measures' stamp: 'RavasiAronson 6/5/2012 00:24'!
oneSquaredSecond

	^Measure withAmount: 1 ofUnit: Unit squaredSecond  ! !

!MeasureTest methodsFor: 'time units' stamp: 'RavasiAronson 5/30/2012 20:43'!
second
	
	^Unit second ! !

!MeasureTest methodsFor: 'time measures' stamp: 'RavasiAronson 5/30/2012 21:17'!
sixtyMinutes
	
	^Measure withAmount: 60 ofUnit: (Unit minute) ! !

!MeasureTest methodsFor: 'time measures' stamp: 'RavasiAronson 6/4/2012 19:56'!
sixtyOneSeconds
	
	^Measure withAmount: 61 ofUnit: (Unit second) ! !

!MeasureTest methodsFor: 'time measures' stamp: 'RavasiAronson 5/30/2012 20:12'!
sixtySeconds
	
		^Measure withAmount: 60  ofUnit: (Unit second) ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:05'!
test01ObjectsRepresentingSameMeasureShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'RavasiAronson 5/30/2012 20:08'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:08'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:11'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'milimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'RavasiAronson 5/30/2012 20:43'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celsius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:19'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:41'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:53'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'RavasiAronson 6/4/2012 20:08'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self twoMeters  / self oneSecond) = self twoMetersBySecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'efo 5/2/2011 20:56'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'RavasiAronson 5/30/2012 20:32'!
thirtyTwoFahrenheits
	
	^Measure withAmount: 32 ofUnit: (Unit fahrenheit)! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'RavasiAronson 5/30/2012 21:17'!
twentyFourHours
	
	^Measure withAmount: 24 ofUnit: (Unit hour) ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'RavasiAronson 6/4/2012 19:56'!
twoCelsius
	
	^Measure withAmount: 2 ofUnit: (Unit celsius) ! !

!MeasureTest methodsFor: 'distance measures' stamp: 'RavasiAronson 5/30/2012 20:15'!
twoHundredCentimeters
	
	^Measure withAmount: 200  ofUnit: (Unit centimeter) ! !

!MeasureTest methodsFor: 'distance measures' stamp: 'RavasiAronson 5/30/2012 20:11'!
twoMeters
	
	^Measure withAmount: 2 ofUnit: Unit meter ! !

!MeasureTest methodsFor: 'compound measures' stamp: 'RavasiAronson 6/5/2012 01:14'!
twoMetersBySecond

	^Measure withAmount: 2 ofUnit: Unit meterPerSecond! !

!MeasureTest methodsFor: 'compound measures' stamp: 'RavasiAronson 6/5/2012 01:22'!
twoMetersPerSquaredSecond

	^Measure withAmount: 2 ofUnit: Unit meterPerSquaredSecond  ! !

!MeasureTest methodsFor: 'compound measures' stamp: 'RavasiAronson 6/5/2012 00:30'!
twoMetersTimesSecond

	^Measure withAmount: 2 ofUnit: Unit meterTimesSecond  ! !

!MeasureTest methodsFor: 'time measures' stamp: 'RavasiAronson 6/4/2012 19:56'!
twoSeconds
	
	^Measure withAmount: 2 ofUnit: (Unit second) ! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'RavasiAronson 5/30/2012 20:13'!
zeroCelsius
	
	^Measure withAmount: 0  ofUnit: (Unit celsius) ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'RavasiAronson 6/4/2012 19:59'!
zeroKelvin
	
	^Measure withAmount: 0 ofUnit: Unit kelvin ! !

!MeasureTest methodsFor: 'distance measures' stamp: 'RavasiAronson 6/4/2012 19:59'!
zeroMeters

	^Measure withAmount: 0 ofUnit: Unit meter ! !

!MeasureTest methodsFor: 'time measures' stamp: 'RavasiAronson 6/4/2012 19:59'!
zeroSeconds
	
	^Measure withAmount: 0 ofUnit: Unit second  ! !
